diff -uN reload1-0.1/COPYING.LGPL reload1-1.0/COPYING.LGPL
--- reload1-0.1/COPYING.LGPL	2003-01-16 16:59:23.000000000 -0800
+++ reload1-1.0/COPYING.LGPL	1969-12-31 16:00:00.000000000 -0800
@@ -1,437 +0,0 @@
-		  GNU LIBRARY GENERAL PUBLIC LICENSE
-		       Version 2, June 1991
-
- Copyright (C) 1991 Free Software Foundation, Inc.
-    		    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- Everyone is permitted to copy and distribute verbatim copies
- of this license document, but changing it is not allowed.
-
-[This is the first released version of the library GPL.  It is
- numbered 2 because it goes with version 2 of the ordinary GPL.]
-
-			    Preamble
-
-  The licenses for most software are designed to take away your
-freedom to share and change it.  By contrast, the GNU General Public
-Licenses are intended to guarantee your freedom to share and change
-free software--to make sure the software is free for all its users.
-
-  This license, the Library General Public License, applies to some
-specially designated Free Software Foundation software, and to any
-other libraries whose authors decide to use it.  You can use it for
-your libraries, too.
-
-  When we speak of free software, we are referring to freedom, not
-price.  Our General Public Licenses are designed to make sure that you
-have the freedom to distribute copies of free software (and charge for
-this service if you wish), that you receive source code or can get it
-if you want it, that you can change the software or use pieces of it
-in new free programs; and that you know you can do these things.
-
-  To protect your rights, we need to make restrictions that forbid
-anyone to deny you these rights or to ask you to surrender the rights.
-These restrictions translate to certain responsibilities for you if
-you distribute copies of the library, or if you modify it.
-
-  For example, if you distribute copies of the library, whether gratis
-or for a fee, you must give the recipients all the rights that we gave
-you.  You must make sure that they, too, receive or can get the source
-code.  If you link a program with the library, you must provide
-complete object files to the recipients so that they can relink them
-with the library, after making changes to the library and recompiling
-it.  And you must show them these terms so they know their rights.
-
-  Our method of protecting your rights has two steps: (1) copyright
-the library, and (2) offer you this license which gives you legal
-permission to copy, distribute and/or modify the library.
-
-  Also, for each distributor's protection, we want to make certain
-that everyone understands that there is no warranty for this free
-library.  If the library is modified by someone else and passed on, we
-want its recipients to know that what they have is not the original
-version, so that any problems introduced by others will not reflect on
-the original authors' reputations.
-
-  Finally, any free program is threatened constantly by software
-patents.  We wish to avoid the danger that companies distributing free
-software will individually obtain patent licenses, thus in effect
-transforming the program into proprietary software.  To prevent this,
-we have made it clear that any patent must be licensed for everyone's
-free use or not licensed at all.
-
-  Most GNU software, including some libraries, is covered by the ordinary
-GNU General Public License, which was designed for utility programs.  This
-license, the GNU Library General Public License, applies to certain
-designated libraries.  This license is quite different from the ordinary
-one; be sure to read it in full, and don't assume that anything in it is
-the same as in the ordinary license.
-
-  The reason we have a separate public license for some libraries is that
-they blur the distinction we usually make between modifying or adding to a
-program and simply using it.  Linking a program with a library, without
-changing the library, is in some sense simply using the library, and is
-analogous to running a utility program or application program.  However, in
-a textual and legal sense, the linked executable is a combined work, a
-derivative of the original library, and the ordinary General Public License
-treats it as such.
-
-  Because of this blurred distinction, using the ordinary General
-Public License for libraries did not effectively promote software
-sharing, because most developers did not use the libraries.  We
-concluded that weaker conditions might promote sharing better.
-
-  However, unrestricted linking of non-free programs would deprive the
-users of those programs of all benefit from the free status of the
-libraries themselves.  This Library General Public License is intended to
-permit developers of non-free programs to use free libraries, while
-preserving your freedom as a user of such programs to change the free
-libraries that are incorporated in them.  (We have not seen how to achieve
-this as regards changes in header files, but we have achieved it as regards
-changes in the actual functions of the Library.)  The hope is that this
-will lead to faster development of free libraries.
-
-  The precise terms and conditions for copying, distribution and
-modification follow.  Pay close attention to the difference between a
-"work based on the library" and a "work that uses the library".  The
-former contains code derived from the library, while the latter only
-works together with the library.
-
-  Note that it is possible for a library to be covered by the ordinary
-General Public License rather than by this special one.
-
-		  GNU LIBRARY GENERAL PUBLIC LICENSE
-   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
-
-  0. This License Agreement applies to any software library which
-contains a notice placed by the copyright holder or other authorized
-party saying it may be distributed under the terms of this Library
-General Public License (also called "this License").  Each licensee is
-addressed as "you".
-
-  A "library" means a collection of software functions and/or data
-prepared so as to be conveniently linked with application programs
-(which use some of those functions and data) to form executables.
-
-  The "Library", below, refers to any such software library or work
-which has been distributed under these terms.  A "work based on the
-Library" means either the Library or any derivative work under
-copyright law: that is to say, a work containing the Library or a
-portion of it, either verbatim or with modifications and/or translated
-straightforwardly into another language.  (Hereinafter, translation is
-included without limitation in the term "modification".)
-
-  "Source code" for a work means the preferred form of the work for
-making modifications to it.  For a library, complete source code means
-all the source code for all modules it contains, plus any associated
-interface definition files, plus the scripts used to control compilation
-and installation of the library.
-
-  Activities other than copying, distribution and modification are not
-covered by this License; they are outside its scope.  The act of
-running a program using the Library is not restricted, and output from
-such a program is covered only if its contents constitute a work based
-on the Library (independent of the use of the Library in a tool for
-writing it).  Whether that is true depends on what the Library does
-and what the program that uses the Library does.
-  
-  1. You may copy and distribute verbatim copies of the Library's
-complete source code as you receive it, in any medium, provided that
-you conspicuously and appropriately publish on each copy an
-appropriate copyright notice and disclaimer of warranty; keep intact
-all the notices that refer to this License and to the absence of any
-warranty; and distribute a copy of this License along with the
-Library.
-
-  You may charge a fee for the physical act of transferring a copy,
-and you may at your option offer warranty protection in exchange for a
-fee.
-
-  2. You may modify your copy or copies of the Library or any portion
-of it, thus forming a work based on the Library, and copy and
-distribute such modifications or work under the terms of Section 1
-above, provided that you also meet all of these conditions:
-
-    a) The modified work must itself be a software library.
-
-    b) You must cause the files modified to carry prominent notices
-    stating that you changed the files and the date of any change.
-
-    c) You must cause the whole of the work to be licensed at no
-    charge to all third parties under the terms of this License.
-
-    d) If a facility in the modified Library refers to a function or a
-    table of data to be supplied by an application program that uses
-    the facility, other than as an argument passed when the facility
-    is invoked, then you must make a good faith effort to ensure that,
-    in the event an application does not supply such function or
-    table, the facility still operates, and performs whatever part of
-    its purpose remains meaningful.
-
-    (For example, a function in a library to compute square roots has
-    a purpose that is entirely well-defined independent of the
-    application.  Therefore, Subsection 2d requires that any
-    application-supplied function or table used by this function must
-    be optional: if the application does not supply it, the square
-    root function must still compute square roots.)
-
-These requirements apply to the modified work as a whole.  If
-identifiable sections of that work are not derived from the Library,
-and can be reasonably considered independent and separate works in
-themselves, then this License, and its terms, do not apply to those
-sections when you distribute them as separate works.  But when you
-distribute the same sections as part of a whole which is a work based
-on the Library, the distribution of the whole must be on the terms of
-this License, whose permissions for other licensees extend to the
-entire whole, and thus to each and every part regardless of who wrote
-it.
-
-Thus, it is not the intent of this section to claim rights or contest
-your rights to work written entirely by you; rather, the intent is to
-exercise the right to control the distribution of derivative or
-collective works based on the Library.
-
-In addition, mere aggregation of another work not based on the Library
-with the Library (or with a work based on the Library) on a volume of
-a storage or distribution medium does not bring the other work under
-the scope of this License.
-
-  3. You may opt to apply the terms of the ordinary GNU General Public
-License instead of this License to a given copy of the Library.  To do
-this, you must alter all the notices that refer to this License, so
-that they refer to the ordinary GNU General Public License, version 2,
-instead of to this License.  (If a newer version than version 2 of the
-ordinary GNU General Public License has appeared, then you can specify
-that version instead if you wish.)  Do not make any other change in
-these notices.
-
-  Once this change is made in a given copy, it is irreversible for
-that copy, so the ordinary GNU General Public License applies to all
-subsequent copies and derivative works made from that copy.
-
-  This option is useful when you wish to copy part of the code of
-the Library into a program that is not a library.
-
-  4. You may copy and distribute the Library (or a portion or
-derivative of it, under Section 2) in object code or executable form
-under the terms of Sections 1 and 2 above provided that you accompany
-it with the complete corresponding machine-readable source code, which
-must be distributed under the terms of Sections 1 and 2 above on a
-medium customarily used for software interchange.
-
-  If distribution of object code is made by offering access to copy
-from a designated place, then offering equivalent access to copy the
-source code from the same place satisfies the requirement to
-distribute the source code, even though third parties are not
-compelled to copy the source along with the object code.
-
-  5. A program that contains no derivative of any portion of the
-Library, but is designed to work with the Library by being compiled or
-linked with it, is called a "work that uses the Library".  Such a
-work, in isolation, is not a derivative work of the Library, and
-therefore falls outside the scope of this License.
-
-  However, linking a "work that uses the Library" with the Library
-creates an executable that is a derivative of the Library (because it
-contains portions of the Library), rather than a "work that uses the
-library".  The executable is therefore covered by this License.
-Section 6 states terms for distribution of such executables.
-
-  When a "work that uses the Library" uses material from a header file
-that is part of the Library, the object code for the work may be a
-derivative work of the Library even though the source code is not.
-Whether this is true is especially significant if the work can be
-linked without the Library, or if the work is itself a library.  The
-threshold for this to be true is not precisely defined by law.
-
-  If such an object file uses only numerical parameters, data
-structure layouts and accessors, and small macros and small inline
-functions (ten lines or less in length), then the use of the object
-file is unrestricted, regardless of whether it is legally a derivative
-work.  (Executables containing this object code plus portions of the
-Library will still fall under Section 6.)
-
-  Otherwise, if the work is a derivative of the Library, you may
-distribute the object code for the work under the terms of Section 6.
-Any executables containing that work also fall under Section 6,
-whether or not they are linked directly with the Library itself.
-
-  6. As an exception to the Sections above, you may also compile or
-link a "work that uses the Library" with the Library to produce a
-work containing portions of the Library, and distribute that work
-under terms of your choice, provided that the terms permit
-modification of the work for the customer's own use and reverse
-engineering for debugging such modifications.
-
-  You must give prominent notice with each copy of the work that the
-Library is used in it and that the Library and its use are covered by
-this License.  You must supply a copy of this License.  If the work
-during execution displays copyright notices, you must include the
-copyright notice for the Library among them, as well as a reference
-directing the user to the copy of this License.  Also, you must do one
-of these things:
-
-    a) Accompany the work with the complete corresponding
-    machine-readable source code for the Library including whatever
-    changes were used in the work (which must be distributed under
-    Sections 1 and 2 above); and, if the work is an executable linked
-    with the Library, with the complete machine-readable "work that
-    uses the Library", as object code and/or source code, so that the
-    user can modify the Library and then relink to produce a modified
-    executable containing the modified Library.  (It is understood
-    that the user who changes the contents of definitions files in the
-    Library will not necessarily be able to recompile the application
-    to use the modified definitions.)
-
-    b) Accompany the work with a written offer, valid for at
-    least three years, to give the same user the materials
-    specified in Subsection 6a, above, for a charge no more
-    than the cost of performing this distribution.
-
-    c) If distribution of the work is made by offering access to copy
-    from a designated place, offer equivalent access to copy the above
-    specified materials from the same place.
-
-    d) Verify that the user has already received a copy of these
-    materials or that you have already sent this user a copy.
-
-  For an executable, the required form of the "work that uses the
-Library" must include any data and utility programs needed for
-reproducing the executable from it.  However, as a special exception,
-the source code distributed need not include anything that is normally
-distributed (in either source or binary form) with the major
-components (compiler, kernel, and so on) of the operating system on
-which the executable runs, unless that component itself accompanies
-the executable.
-
-  It may happen that this requirement contradicts the license
-restrictions of other proprietary libraries that do not normally
-accompany the operating system.  Such a contradiction means you cannot
-use both them and the Library together in an executable that you
-distribute.
-
-  7. You may place library facilities that are a work based on the
-Library side-by-side in a single library together with other library
-facilities not covered by this License, and distribute such a combined
-library, provided that the separate distribution of the work based on
-the Library and of the other library facilities is otherwise
-permitted, and provided that you do these two things:
-
-    a) Accompany the combined library with a copy of the same work
-    based on the Library, uncombined with any other library
-    facilities.  This must be distributed under the terms of the
-    Sections above.
-
-    b) Give prominent notice with the combined library of the fact
-    that part of it is a work based on the Library, and explaining
-    where to find the accompanying uncombined form of the same work.
-
-  8. You may not copy, modify, sublicense, link with, or distribute
-the Library except as expressly provided under this License.  Any
-attempt otherwise to copy, modify, sublicense, link with, or
-distribute the Library is void, and will automatically terminate your
-rights under this License.  However, parties who have received copies,
-or rights, from you under this License will not have their licenses
-terminated so long as such parties remain in full compliance.
-
-  9. You are not required to accept this License, since you have not
-signed it.  However, nothing else grants you permission to modify or
-distribute the Library or its derivative works.  These actions are
-prohibited by law if you do not accept this License.  Therefore, by
-modifying or distributing the Library (or any work based on the
-Library), you indicate your acceptance of this License to do so, and
-all its terms and conditions for copying, distributing or modifying
-the Library or works based on it.
-
-  10. Each time you redistribute the Library (or any work based on the
-Library), the recipient automatically receives a license from the
-original licensor to copy, distribute, link with or modify the Library
-subject to these terms and conditions.  You may not impose any further
-restrictions on the recipients' exercise of the rights granted herein.
-You are not responsible for enforcing compliance by third parties to
-this License.
-
-  11. If, as a consequence of a court judgment or allegation of patent
-infringement or for any other reason (not limited to patent issues),
-conditions are imposed on you (whether by court order, agreement or
-otherwise) that contradict the conditions of this License, they do not
-excuse you from the conditions of this License.  If you cannot
-distribute so as to satisfy simultaneously your obligations under this
-License and any other pertinent obligations, then as a consequence you
-may not distribute the Library at all.  For example, if a patent
-license would not permit royalty-free redistribution of the Library by
-all those who receive copies directly or indirectly through you, then
-the only way you could satisfy both it and this License would be to
-refrain entirely from distribution of the Library.
-
-If any portion of this section is held invalid or unenforceable under any
-particular circumstance, the balance of the section is intended to apply,
-and the section as a whole is intended to apply in other circumstances.
-
-It is not the purpose of this section to induce you to infringe any
-patents or other property right claims or to contest validity of any
-such claims; this section has the sole purpose of protecting the
-integrity of the free software distribution system which is
-implemented by public license practices.  Many people have made
-generous contributions to the wide range of software distributed
-through that system in reliance on consistent application of that
-system; it is up to the author/donor to decide if he or she is willing
-to distribute software through any other system and a licensee cannot
-impose that choice.
-
-This section is intended to make thoroughly clear what is believed to
-be a consequence of the rest of this License.
-
-  12. If the distribution and/or use of the Library is restricted in
-certain countries either by patents or by copyrighted interfaces, the
-original copyright holder who places the Library under this License may add
-an explicit geographical distribution limitation excluding those countries,
-so that distribution is permitted only in or among countries not thus
-excluded.  In such case, this License incorporates the limitation as if
-written in the body of this License.
-
-  13. The Free Software Foundation may publish revised and/or new
-versions of the Library General Public License from time to time.
-Such new versions will be similar in spirit to the present version,
-but may differ in detail to address new problems or concerns.
-
-Each version is given a distinguishing version number.  If the Library
-specifies a version number of this License which applies to it and
-"any later version", you have the option of following the terms and
-conditions either of that version or of any later version published by
-the Free Software Foundation.  If the Library does not specify a
-license version number, you may choose any version ever published by
-the Free Software Foundation.
-
-  14. If you wish to incorporate parts of the Library into other free
-programs whose distribution conditions are incompatible with these,
-write to the author to ask for permission.  For software which is
-copyrighted by the Free Software Foundation, write to the Free
-Software Foundation; we sometimes make exceptions for this.  Our
-decision will be guided by the two goals of preserving the free status
-of all derivatives of our free software and of promoting the sharing
-and reuse of software generally.
-
-			    NO WARRANTY
-
-  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
-WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
-EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
-OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
-KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
-IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
-LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
-THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
-
-  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
-WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
-AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
-FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
-CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
-LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
-RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
-FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
-SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
-DAMAGES.
-
-		     END OF TERMS AND CONDITIONS
diff -uN reload1-0.1/Defs.make reload1-1.0/Defs.make
--- reload1-0.1/Defs.make	2003-01-19 15:18:56.000000000 -0800
+++ reload1-1.0/Defs.make	2004-06-13 16:18:42.000000000 -0700
@@ -1,6 +1,6 @@
 
 # Set this to the path + name prefix of your cross toolchain
-TOOLS = ps2-
+TOOLS = ee-
 CC = $(TOOLS)gcc
 AS = $(TOOLS)as
 LD = $(TOOLS)ld
diff -uN reload1-0.1/LICENSE reload1-1.0/LICENSE
--- reload1-0.1/LICENSE	1969-12-31 16:00:00.000000000 -0800
+++ reload1-1.0/LICENSE	2004-06-15 23:19:21.000000000 -0700
@@ -0,0 +1,166 @@
+
+  The Academic Free License
+  v. 2.0
+
+This Academic Free License (the "License") applies to any original work
+of authorship (the "Original Work") whose owner (the "Licensor") has
+placed the following notice immediately following the copyright notice
+for the Original Work:
+
+    *Licensed under the Academic Free License version 2.0*
+
+1) *Grant of Copyright License.* Licensor hereby grants You a
+world-wide, royalty-free, non-exclusive, perpetual, sublicenseable
+license to do the following:
+
+    a) to reproduce the Original Work in copies;
+
+    b) to prepare derivative works ("Derivative Works") based upon the
+    Original Work;
+
+    c) to distribute copies of the Original Work and Derivative Works to
+    the public;
+
+    d) to perform the Original Work publicly; and
+
+    e) to display the Original Work publicly.
+
+2) *Grant of Patent License.* Licensor hereby grants You a world-wide,
+royalty-free, non-exclusive, perpetual, sublicenseable license, under
+patent claims owned or controlled by the Licensor that are embodied in
+the Original Work as furnished by the Licensor, to make, use, sell and
+offer for sale the Original Work and Derivative Works.
+
+3) *Grant of Source Code License.* The term "Source Code" means the
+preferred form of the Original Work for making modifications to it and
+all available documentation describing how to modify the Original Work.
+Licensor hereby agrees to provide a machine-readable copy of the Source
+Code of the Original Work along with each copy of the Original Work that
+Licensor distributes. Licensor reserves the right to satisfy this
+obligation by placing a machine-readable copy of the Source Code in an
+information repository reasonably calculated to permit inexpensive and
+convenient access by You for as long as Licensor continues to distribute
+the Original Work, and by publishing the address of that information
+repository in a notice immediately following the copyright notice that
+applies to the Original Work.
+
+4) *Exclusions From License Grant. *Neither the names of Licensor, nor
+the names of any contributors to the Original Work, nor any of their
+trademarks or service marks, may be used to endorse or promote products
+derived from this Original Work without express prior written permission
+of the Licensor. Nothing in this License shall be deemed to grant any
+rights to trademarks, copyrights, patents, trade secrets or any other
+intellectual property of Licensor except as expressly stated herein. No
+patent license is granted to make, use, sell or offer to sell
+embodiments of any patent claims other than the licensed claims defined
+in Section 2. No right is granted to the trademarks of Licensor even if
+such marks are included in the Original Work. Nothing in this License
+shall be interpreted to prohibit Licensor from licensing under different
+terms from this License any Original Work that Licensor otherwise would
+have a right to license.
+
+5) This section intentionally omitted.
+
+6) *Attribution Rights.* You must retain, in the Source Code of any
+Derivative Works that You create, all copyright, patent or trademark
+notices from the Source Code of the Original Work, as well as any
+notices of licensing and any descriptive text identified therein as an
+"Attribution Notice." You must cause the Source Code for any Derivative
+Works that You create to carry a prominent Attribution Notice reasonably
+calculated to inform recipients that You have modified the Original Work.
+
+7) *Warranty of Provenance and Disclaimer of Warranty.* Licensor
+warrants that the copyright in and to the Original Work and the patent
+rights granted herein by Licensor are owned by the Licensor or are
+sublicensed to You under the terms of this License with the permission
+of the contributor(s) of those copyrights and patent rights. Except as
+expressly stated in the immediately proceeding sentence, the Original
+Work is provided under this License on an "AS IS" BASIS and WITHOUT
+WARRANTY, either express or implied, including, without limitation, the
+warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS FOR A
+PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
+WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential
+part of this License. No license to Original Work is granted hereunder
+except under this disclaimer.
+
+8) *Limitation of Liability.* Under no circumstances and under no legal
+theory, whether in tort (including negligence), contract, or otherwise,
+shall the Licensor be liable to any person for any direct, indirect,
+special, incidental, or consequential damages of any character arising
+as a result of this License or the use of the Original Work including,
+without limitation, damages for loss of goodwill, work stoppage,
+computer failure or malfunction, or any and all other commercial damages
+or losses. This limitation of liability shall not apply to liability for
+death or personal injury resulting from Licensor's negligence to the
+extent applicable law prohibits such limitation. Some jurisdictions do
+not allow the exclusion or limitation of incidental or consequential
+damages, so this exclusion and limitation may not apply to You.
+
+9) *Acceptance and Termination.* If You distribute copies of the
+Original Work or a Derivative Work, You must make a reasonable effort
+under the circumstances to obtain the express assent of recipients to
+the terms of this License. Nothing else but this License (or another
+written agreement between Licensor and You) grants You permission to
+create Derivative Works based upon the Original Work or to exercise any
+of the rights granted in Section 1 herein, and any attempt to do so
+except under the terms of this License (or another written agreement
+between Licensor and You) is expressly prohibited by U.S. copyright law,
+the equivalent laws of other countries, and by international treaty.
+Therefore, by exercising any of the rights granted to You in Section 1
+herein, You indicate Your acceptance of this License and all of its
+terms and conditions.
+
+10) *Termination for Patent Action.* This License shall terminate
+automatically and You may no longer exercise any of the rights granted
+to You by this License as of the date You commence an action, including
+a cross-claim or counterclaim, for patent infringement (i) against
+Licensor with respect to a patent applicable to software or (ii) against
+any entity with respect to a patent applicable to the Original Work (but
+excluding combinations of the Original Work with other software or
+hardware).
+
+11) *Jurisdiction, Venue and Governing Law.* Any action or suit relating
+to this License may be brought only in the courts of a jurisdiction
+wherein the Licensor resides or in which Licensor conducts its primary
+business, and under the laws of that jurisdiction excluding its
+conflict-of-law provisions. The application of the United Nations
+Convention on Contracts for the International Sale of Goods is expressly
+excluded. Any use of the Original Work outside the scope of this License
+or after its termination shall be subject to the requirements and
+penalties of the U.S. Copyright Act, 17 U.S.C. § 101 et seq., the
+equivalent laws of other countries, and international treaty. This
+section shall survive the termination of this License.
+
+12) *Attorneys Fees.* In any action to enforce the terms of this License
+or seeking damages relating thereto, the prevailing party shall be
+entitled to recover its costs and expenses, including, without
+limitation, reasonable attorneys' fees and costs incurred in connection
+with such action, including any appeal of such action. This section
+shall survive the termination of this License.
+
+13) *Miscellaneous.* This License represents the complete agreement
+concerning the subject matter hereof. If any provision of this License
+is held to be unenforceable, such provision shall be reformed only to
+the extent necessary to make it enforceable.
+
+14) *Definition of "You" in This License.* "You" throughout this
+License, whether in upper or lower case, means an individual or a legal
+entity exercising rights under, and complying with all of the terms of,
+this License. For legal entities, "You" includes any entity that
+controls, is controlled by, or is under common control with you. For
+purposes of this definition, "control" means (i) the power, direct or
+indirect, to cause the direction or management of such entity, whether
+by contract or otherwise, or (ii) ownership of fifty percent (50%) or
+more of the outstanding shares, or (iii) beneficial ownership of such
+entity.
+
+15) *Right to Use.* You may use the Original Work in all ways not
+otherwise restricted or conditioned by this License or by law, and
+Licensor promises not to interfere with or be responsible for such uses
+by You.
+
+This license is Copyright (C) 2003 Lawrence E. Rosen. All rights
+reserved. Permission is hereby granted to copy and distribute this
+license without modification. This license may not be modified without
+the express written permission of its copyright owner.
+
diff -uN reload1-0.1/README reload1-1.0/README
--- reload1-0.1/README	2003-01-19 18:03:30.000000000 -0800
+++ reload1-1.0/README	2004-06-15 23:18:59.000000000 -0700
@@ -1,17 +1,15 @@
-PS2 Kernel Reloader 0.1
+PS2 Kernel Reloader 1.0
 =======================
 
 This archive contains the source to a simple loader for the RTE.  The loader
 takes an ELF file (linked in at build time) and executes it under the PS2's
 native operating system.  This enables one to write programs that run under the
-native OS, or as some folks like to refer to them "Naplink-compatible"
-progams.
+native OS, or as some folks like to refer to them "Naplink-compatible" or
+ps2dev progams.
 
 There's not much to say about its operation, and the source should be
-self-explainatory.  The main caveat is that it's not entirely portable, and
-I've heard reports (from preliminary test programs) that it will fail on the
-3900x series (the latest iteration of PS2).  I plan to fix this in a later
-version.
+self-explainatory.  The program should work on all current revisions of the
+PS2.
 
 The other problem with this particular implementation is that the attached boot
 ELF sits behind the reload1 program, and the PS2's OS clears "user memory"
@@ -19,28 +17,24 @@
 reload1 program loads at 0x00030000 (the lowest address that's safe to use for
 this), so that means the maximum size of the attached ELF file is ~316Kb.
 
-I am working on a seperate, dual RTE/native bootloader, I hope to have it
-ready for testing within the next week.  This program itself is over a month
-and a half late, as I wanted to ship this with the loader, and also ship a
-demo using it, but both took up too much time so I decided to get this out
-there.
-
 Oh, the provided stage2.elf/testmode.elf loads and executes the built-in
 "TESTMODE" program ... be sure to hold on to your Dualshock.
 
-The source code in this archive is licensed under the GNU LGPL.
+The source code in this archive is licensed under the Academic Free License,
+version 2.0.  See the file called LICENSE for more information.
 
 Usage
 =====
 
 A Makefile has been provided to build the reload1 program and attach the boot
-ELF.  To build reload1, you must have a cross-compiler toolchain similiar to
-the one found at http://ps2dev.sourceforge.net/.  The PS2 Linux compiler WILL
-NOT WORK, DO NOT ASK me about it, and DON'T WASTE TIME trying to use it.
+ELF.  To build reload1, you must have a PS2 cross-compiler toolchain (GCC,
+binutils, etc.) You can find patches and a build script at
+http://oopo.net/consoledev/.  The PS2 Linux compiler WILL NOT WORK, DO NOT ASK
+me about it, and DON'T WASTE TIME trying to use it.
 
 Edit Defs.make and change the TOOLS variable to the location and prefix of your
-tools (for example, if your mips64r5900-sce-elf tools are installed in
-/usr/local/ps2dev, set TOOLS to /usr/local/ps2dev/bin/mips64r5900-sce-elf-).
+EE toolchain (for example, if your ee-gcc toolchain is installed in
+/usr/local/ps2dev, set TOOLS to /usr/local/ps2dev/bin/ee-).
 
 Run "make" and point the variable STAGE2 to the location of the ELF you want to
 boot:
@@ -64,5 +58,5 @@
 And many other PS2 homebrew sites.
 
 --
-M. R. Brown <mrbrown@0xd6.org>
-1/19/03
+Marcus R. Brown <mrbrown@0xd6.org>
+6/15/04
diff -uN reload1-0.1/defs.h reload1-1.0/defs.h
--- reload1-0.1/defs.h	2003-01-19 17:57:32.000000000 -0800
+++ reload1-1.0/defs.h	2004-06-15 23:22:36.000000000 -0700
@@ -1,10 +1,10 @@
 /*
  * defs.h - Misc. definitions.
  *
- * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
+ * Copyright (c) 2003-2004 Marcus R. Brown <mrbrown@0xd6.org>
  *
- * This code is licensed under the LGPL version 2.  See the file
- * "COPYING.LGPL" in the main directory of this archive for more information.
+ * Licensed under the AFL v2.0. See the file LICENSE included with this
+ * distribution for licensing terms.
  */
 #ifndef _DEFS_H_
 #define _DEFS_H_
diff -uN reload1-0.1/reload1.c reload1-1.0/reload1.c
--- reload1-0.1/reload1.c	2003-01-19 15:31:43.000000000 -0800
+++ reload1-1.0/reload1.c	2004-06-15 23:20:19.000000000 -0700
@@ -1,10 +1,10 @@
 /*
  * reload1.c - Bootstrap and reset the PS2 OS from the RTE.
  *
- * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
+ * Copyright (c) 2003-2004 Marcus R. Brown <mrbrown@0xd6.org>
  *
- * This code is licensed under the LGPL version 2.  See the file
- * "COPYING.LGPL" in the main directory of this archive for more information.
+ * Licensed under the AFL v2.0. See the file LICENSE included with this
+ * distribution for licensing terms.
  */
 
 #include "types.h"
@@ -59,11 +59,13 @@
 static int eeload_setup(char *name, u32 pc, u32 sp, u32 val);
 static void reset_iop();
 
+void superflush();
+
 void _start()
 {
 	u32 kaddr, ksize, i;
 
-	asm ("li\t$29,%0\n\t"::"i" (0x100000));
+	asm volatile ("li\t$29,%0\n\t"::"i" (0x100000));
 
 	/* Reboot the IOP first. */
 	reset_iop();
@@ -73,14 +75,19 @@
 	if (!romfs_findfile("KERNEL\0\0\0", &kaddr, &ksize, NULL))
 		goto spin;
 
+	*((u32 *)(0xa0000000 | (u32)&kaddr)) = kaddr;
+	*((u32 *)(0xa0000000 | (u32)&ksize)) = ksize;
+
 	/* Run uncached, to avoid flushing the caches later */
-	asm (""			\
+	asm volatile (""	\
 	"la\t$8,1f\n\t"		\
 	"lui\t$9,0x2000\n\t"	\
 	"or\t$8,$9\n\t"		\
 	"jr\t$8\n\t"		\
 	"nop\n\t1:\n\t":::"$8", "$9");
 
+	superflush();
+
 	/*
 	 * Clear kernel RAM up to where we sit, then load the kernel itself.
 	 */
@@ -96,17 +103,19 @@
 	_sw(ramsize, 0x70003ff0);
 
 	/*
-	 * This code is BIOS dependant.  From what I've heard, it doesn't work
-	 * on the 3900x series.  Note that this is only one method of trapping
-	 * the kernel boot sequence, I'm looking for a more portable way to do
-	 * this.
+	 * This code is somewhat BIOS dependant.  It should work on everything
+	 * up to and including the 50000 series.
 	 */
 	_sw(0x0c000000 | (0x3ffffff & ((u32)eeload_setup >> 2)), 0xa00010b0);
 
+	superflush();
+
 	/*
 	 * Execute the kernel startup routine.
 	 */
-	asm ("j\t%0" : : "i" (0xa0001000));
+	asm volatile ("li\t$29,%0\n\t" : : "i" (0x70003ff0));
+	asm volatile ("li\t$8,%0\n\t" : : "i" (0x80001000));
+	asm volatile ("jr\t$8");
 
 spin:
 	while (1) ;
@@ -124,14 +133,17 @@
 static int eeload_setup(char *filename, u32 pc, u32 sp, u32 val)
 {
 	int (*_thread_setup)(char *, u32, u32, u32);
-	void (*_cache_func)();
 	struct elf_header *eh = (struct elf_header *)&_binary_elf_start;
 	struct elf_pheader *eph;
 	void *source;
 	int index, i;
+	u32 destaddr = 0x80005390;
+
+	/* Check for the thread_setup() routine in 5000x series kernels.  */
+	if ((_lw(destaddr - 8) & 0xbd270000) == 0xbd270000)
+		destaddr -= 8;
 
-	/* possibly BIOS dependent */
-	(int (**)(char *, u32, u32, u32))_thread_setup = 0x80005390;
+	(int (**)(char *, u32, u32, u32))_thread_setup = destaddr;
 
 	if (_lw((u32)&eh->ident) != ELF_MAGIC)
 		return _thread_setup(filename, pc, sp, val);
@@ -157,12 +169,7 @@
 					eph[i].memsz - eph[i].filesz);
 	}
 
-	/* Writeback the data cache */
-	(void (**)())_cache_func = 0x80002ac0;
-	_cache_func();
-	/* Invalidate the insn cache */
-	(void (**)())_cache_func = 0x80002a80;
-	_cache_func();
+	superflush();
 
 	return index;
 }
@@ -208,3 +215,38 @@
 		;
 	sif_reg_set(4, 0x40000);
 }
+
+/* Flushback the D-Cache and invalidate the I-Cache.  */
+asm (""				\
+"	.text\n\t"		\
+"	.p2align 6\n\t"		\
+"	.set noreorder\n\t"	\
+"superflush:\n\t"		\
+"	li	$8, 0\n\t"	\
+"1:"				\
+"	sync\n\t"		\
+"	cache	0x14, 0($8)\n\t"\
+"	sync\n\t"		\
+"	cache	0x14, 1($8)\n\t"\
+"	sync\n\t"		\
+"	addiu	$8, 0x40\n\t"	\
+"	slti	$9, $8, 0x1000\n\t"\
+"	bnez	$9, 1b\n\t"	\
+"	nop\n\t"		\
+""				\
+"	li	$8, 0\n\t"	\
+"2:"				\
+"	sync\n\t"		\
+"	cache	7, 0($8)\n\t"	\
+"	cache	7, 1($8)\n\t"	\
+"	sync\n\t"		\
+"	addiu	$8, 0x40\n\t"	\
+"	slti	$9, $8, 0x2000\n\t"\
+"	bnez	$9, 2b\n\t"	\
+"	nop\n\t"		\
+"	cache	0xc, 0($0)\n\t"	\
+"	sync\n\t"		\
+""				\
+"	jr	$31\n\t"	\
+"	nop\n\t"		\
+"");
diff -uN reload1-0.1/romfs.c reload1-1.0/romfs.c
--- reload1-0.1/romfs.c	2003-01-19 18:13:28.000000000 -0800
+++ reload1-1.0/romfs.c	2004-06-15 23:21:08.000000000 -0700
@@ -1,10 +1,10 @@
 /*
  * romfs.c - Simple code to locate files within the ROM-based filesystem.
  *
- * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
+ * Copyright (c) 2003-2004 Marcus R. Brown <mrbrown@0xd6.org>
  *
- * This code is licensed under the LGPL version 2.  See the file
- * "COPYING.LGPL" in the main directory of this archive for more information.
+ * Licensed under the AFL v2.0. See the file LICENSE included with this
+ * distribution for licensing terms.
  */
 
 #include "types.h"
diff -uN reload1-0.1/rtesif.c reload1-1.0/rtesif.c
--- reload1-0.1/rtesif.c	2003-01-19 18:08:21.000000000 -0800
+++ reload1-1.0/rtesif.c	2004-06-15 23:24:43.000000000 -0700
@@ -1,10 +1,10 @@
 /*
  * rtesif.c - RTE SIF support code.
  *
- * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
+ * Copyright (c) 2003-2004 Marcus R. Brown <mrbrown@0xd6.org>
  *
- * This code is licensed under the LGPL version 2.  See the file
- * "COPYING.LGPL" in the main directory of this archive for more information.
+ * Licensed under the AFL v2.0. See the file LICENSE included with this
+ * distribution for licensing terms.
  */
 
 #include "types.h"
diff -uN reload1-0.1/types.h reload1-1.0/types.h
--- reload1-0.1/types.h	2003-01-19 18:05:36.000000000 -0800
+++ reload1-1.0/types.h	2004-06-15 23:23:35.000000000 -0700
@@ -1,10 +1,10 @@
 /*
  * types.h - Type definitions.
  *
- * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
+ * Copyright (c) 2003-2004 Marcus R. Brown <mrbrown@0xd6.org>
  *
- * This code is licensed under the LGPL version 2.  See the file
- * "COPYING.LGPL" in the main directory of this archive for more information.
+ * Licensed under the AFL v2.0. See the file LICENSE included with this
+ * distribution for licensing terms.
  */
 #ifndef _TYPES_H_
 #define _TYPES_H_
